diff --git a/examples/server.c b/examples/server.c
index 0508f368364..a17b2d26bc3 100644
--- a/examples/server.c
+++ b/examples/server.c
@@ -244,7 +244,7 @@ int main(int argc, char** argv) {
   else if (dataSourceCopy->read != dateDataSource.read)
     UA_LOG_WARNING(logger, UA_LOGCATEGORY_USERLAND, "The returned dataSource is not the same as we set?");
   else
-    UA_Server_setAttribute_DataSource(server, nodeId_currentTime, dataSourceCopy);
+    UA_Server_setAttribute_DataSource(server, nodeId_currentTime, *dataSourceCopy);
   free(dataSourceCopy);
 #ifndef _WIN32
   //cpu temperature monitoring for linux machines
diff --git a/examples/server_variable.c b/examples/server_variable.c
index 8e5bb990eea..0c2cd58a456 100644
--- a/examples/server_variable.c
+++ b/examples/server_variable.c
@@ -22,6 +22,14 @@ static void stopHandler(int sign) {
     running = 0;
 }
 
+static void onRead(void *handle, const UA_NodeId nodeid,  const UA_Variant *data, const UA_NumericRange *range){
+    UA_LOG_INFO(logger, UA_LOGCATEGORY_USERLAND, "onRead; handle is: %i", (UA_Int32)handle);
+}
+
+static void onWrite(void *handle, const UA_NodeId nodeid, const UA_Variant *data, const UA_NumericRange *range){
+    UA_LOG_INFO(logger, UA_LOGCATEGORY_USERLAND, "onWrite; handle is: %i", (UA_Int32)handle);
+}
+
 int main(int argc, char** argv) {
     signal(SIGINT, stopHandler); /* catches ctrl-c */
 
@@ -44,6 +52,9 @@ int main(int argc, char** argv) {
     UA_Server_addVariableNode(server, myIntegerNodeId, myIntegerName, myIntegerBrowseName, myIntegerBrowseName, 0, 0,
                               parentNodeId, parentReferenceNodeId, myIntegerVariant, NULL);
 
+    UA_UserspaceCallback callback = {(void*)7, onRead, onWrite};
+    UA_Server_setAttribute_UserspaceCallback(server, myIntegerNodeId, callback);
+
     UA_StatusCode retval = UA_Server_run(server, 1, &running);
     UA_Server_delete(server);
 
diff --git a/include/ua_server.h b/include/ua_server.h
index 5ca877bc81c..859edc77777 100644
--- a/include/ua_server.h
+++ b/include/ua_server.h
@@ -119,6 +119,12 @@ typedef struct {
     UA_StatusCode (*write)(void *handle, const UA_NodeId nodeid, const UA_Variant *data, const UA_NumericRange *range);
 } UA_DataSource;
 
+typedef struct {
+    void *handle;
+    void (*onRead)(void *handle, const UA_NodeId nodeid,  const UA_Variant *data, const UA_NumericRange *range);
+    void (*onWrite)(void *handle, const UA_NodeId nodeid, const UA_Variant *data, const UA_NumericRange *range);
+} UA_UserspaceCallback;
+
 /** @brief Add a new namespace to the server. Returns the index of the new namespace */
 UA_UInt16 UA_EXPORT UA_Server_addNamespace(UA_Server *server, const char* name);
 
@@ -378,7 +384,10 @@ UA_Server_setAttribute_method(UA_Server *server, UA_NodeId methodNodeId, UA_Meth
 #endif
 
 UA_StatusCode UA_EXPORT
-UA_Server_setAttribute_DataSource(UA_Server *server, UA_NodeId nodeId, UA_DataSource *value);
+UA_Server_setAttribute_DataSource(UA_Server *server, UA_NodeId nodeId, UA_DataSource value);
+
+UA_StatusCode UA_EXPORT
+UA_Server_setAttribute_UserspaceCallback(UA_Server *server, UA_NodeId nodeId, UA_UserspaceCallback value);
 
 UA_StatusCode UA_EXPORT
 UA_Server_getAttributeValue(UA_Server *server, UA_NodeId nodeId, UA_AttributeId attributeId, void **value);
diff --git a/src/server/ua_nodes.c b/src/server/ua_nodes.c
index 54d78fbbaba..d03df4ce55a 100644
--- a/src/server/ua_nodes.c
+++ b/src/server/ua_nodes.c
@@ -101,7 +101,8 @@ void UA_VariableNode_init(UA_VariableNode *p) {
 	UA_Node_init((UA_Node*)p);
     p->nodeClass = UA_NODECLASS_VARIABLE;
     p->valueSource = UA_VALUESOURCE_VARIANT;
-    UA_Variant_init(&p->value.variant);
+    UA_Variant_init(&p->value.variantAndCallback.variant);
+    p->value.variantAndCallback.callback = (UA_UserspaceCallback){UA_NULL,UA_NULL,UA_NULL};
     p->valueRank = -2; // scalar or array of any dimension
     p->accessLevel = 0;
     p->userAccessLevel = 0;
@@ -119,7 +120,7 @@ UA_VariableNode * UA_VariableNode_new(void) {
 void UA_VariableNode_deleteMembers(UA_VariableNode *p) {
     UA_Node_deleteMembers((UA_Node*)p);
     if(p->valueSource == UA_VALUESOURCE_VARIANT)
-        UA_Variant_deleteMembers(&p->value.variant);
+        UA_Variant_deleteMembers(&p->value.variantAndCallback.variant);
 }
 
 void UA_VariableNode_delete(UA_VariableNode *p) {
@@ -132,9 +133,10 @@ UA_StatusCode UA_VariableNode_copy(const UA_VariableNode *src, UA_VariableNode *
 	UA_StatusCode retval = UA_Node_copy((const UA_Node*)src, (UA_Node*)dst);
     dst->valueRank = src->valueRank;
     dst->valueSource = src->valueSource;
-    if(src->valueSource == UA_VALUESOURCE_VARIANT)
-        retval = UA_Variant_copy(&src->value.variant, &dst->value.variant);
-    else
+    if(src->valueSource == UA_VALUESOURCE_VARIANT){
+        retval = UA_Variant_copy(&src->value.variantAndCallback.variant, &dst->value.variantAndCallback.variant);
+        dst->value.variantAndCallback.callback = src->value.variantAndCallback.callback;
+    }else
         dst->value.dataSource = src->value.dataSource;
     if(retval) {
         UA_VariableNode_deleteMembers(dst);
@@ -152,7 +154,8 @@ void UA_VariableTypeNode_init(UA_VariableTypeNode *p) {
 	UA_Node_init((UA_Node*)p);
     p->nodeClass = UA_NODECLASS_VARIABLETYPE;
     p->valueSource = UA_VALUESOURCE_VARIANT;
-    UA_Variant_init(&p->value.variant);
+    UA_Variant_init(&p->value.variantAndCallback.variant);
+    p->value.variantAndCallback.callback = (UA_UserspaceCallback){UA_NULL, UA_NULL, UA_NULL};
     p->valueRank = -2; // scalar or array of any dimension
     p->isAbstract = UA_FALSE;
 }
@@ -167,7 +170,7 @@ UA_VariableTypeNode * UA_VariableTypeNode_new(void) {
 void UA_VariableTypeNode_deleteMembers(UA_VariableTypeNode *p) {
     UA_Node_deleteMembers((UA_Node*)p);
     if(p->valueSource == UA_VALUESOURCE_VARIANT)
-        UA_Variant_deleteMembers(&p->value.variant);
+        UA_Variant_deleteMembers(&p->value.variantAndCallback.variant);
 }
 
 void UA_VariableTypeNode_delete(UA_VariableTypeNode *p) {
@@ -180,9 +183,10 @@ UA_StatusCode UA_VariableTypeNode_copy(const UA_VariableTypeNode *src, UA_Variab
 	UA_StatusCode retval = UA_Node_copy((const UA_Node*)src, (UA_Node*)dst);
     dst->valueRank = src->valueRank;
     dst->valueSource = src->valueSource;
-    if(src->valueSource == UA_VALUESOURCE_VARIANT)
-        UA_Variant_copy(&src->value.variant, &dst->value.variant);
-    else
+    if(src->valueSource == UA_VALUESOURCE_VARIANT){
+        UA_Variant_copy(&src->value.variantAndCallback.variant, &dst->value.variantAndCallback.variant);
+        dst->value.variantAndCallback.callback = src->value.variantAndCallback.callback;
+    }else
         dst->value.dataSource = src->value.dataSource;
     if(retval) {
         UA_VariableTypeNode_deleteMembers(dst);
diff --git a/src/server/ua_nodes.h b/src/server/ua_nodes.h
index 6c5d98f5a3b..a73917da574 100644
--- a/src/server/ua_nodes.h
+++ b/src/server/ua_nodes.h
@@ -65,7 +65,10 @@ typedef struct {
                              n = -3:  the value can be a scalar or a one dimensional array. */
     UA_ValueSource valueSource;
     union {
+        struct {
         UA_Variant variant;
+        UA_UserspaceCallback callback;
+        } variantAndCallback;
         UA_DataSource dataSource;
     } value;
     /* <--- similar to variabletypenodes up to there--->*/
@@ -87,7 +90,10 @@ typedef struct {
     UA_Int32 valueRank;
     UA_ValueSource valueSource;
     union {
-        UA_Variant variant;
+        struct {
+            UA_Variant variant;
+            UA_UserspaceCallback callback;
+        } variantAndCallback;
         UA_DataSource dataSource;
     } value;
     /* <--- similar to variablenodes up to there--->*/
diff --git a/src/server/ua_server.c b/src/server/ua_server.c
index 693e95495b5..7932681b351 100644
--- a/src/server/ua_server.c
+++ b/src/server/ua_server.c
@@ -300,7 +300,7 @@ createVariableTypeNode(UA_Server *server, char* name, UA_UInt32 variabletypeid,
     copyNames((UA_Node*)variabletype, name);
     variabletype->nodeId.identifier.numeric = variabletypeid;
     variabletype->isAbstract = abstract;
-    variabletype->value.variant.type = &UA_TYPES[UA_TYPES_VARIANT];
+    variabletype->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_VARIANT];
     return variabletype;
 }
 
@@ -842,10 +842,10 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
    UA_VariableNode *serverArray = UA_VariableNode_new();
    copyNames((UA_Node*)serverArray, "ServerArray");
    serverArray->nodeId.identifier.numeric = UA_NS0ID_SERVER_SERVERARRAY;
-   serverArray->value.variant.data = UA_Array_new(&UA_TYPES[UA_TYPES_STRING], 1);
-   serverArray->value.variant.arrayLength = 1;
-   serverArray->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
-   *(UA_String *)serverArray->value.variant.data = UA_STRING_ALLOC(server->config.Application_applicationURI);
+   serverArray->value.variantAndCallback.variant.data = UA_Array_new(&UA_TYPES[UA_TYPES_STRING], 1);
+   serverArray->value.variantAndCallback.variant.arrayLength = 1;
+   serverArray->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
+   *(UA_String *)serverArray->value.variantAndCallback.variant.data = UA_STRING_ALLOC(server->config.Application_applicationURI);
    serverArray->valueRank = 1;
    serverArray->minimumSamplingInterval = 1.0;
    UA_Server_addNode(server, (UA_Node*)serverArray, UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER),
@@ -865,10 +865,10 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
    UA_VariableNode *localeIdArray = UA_VariableNode_new();
    copyNames((UA_Node*)localeIdArray, "LocaleIdArray");
    localeIdArray->nodeId.identifier.numeric = UA_NS0ID_SERVER_SERVERCAPABILITIES_LOCALEIDARRAY;
-   localeIdArray->value.variant.data = UA_Array_new(&UA_TYPES[UA_TYPES_STRING], 1);
-   localeIdArray->value.variant.arrayLength = 1;
-   localeIdArray->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
-   *(UA_String *)localeIdArray->value.variant.data = UA_STRING_ALLOC("en");
+   localeIdArray->value.variantAndCallback.variant.data = UA_Array_new(&UA_TYPES[UA_TYPES_STRING], 1);
+   localeIdArray->value.variantAndCallback.variant.arrayLength = 1;
+   localeIdArray->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
+   *(UA_String *)localeIdArray->value.variantAndCallback.variant.data = UA_STRING_ALLOC("en");
    localeIdArray->valueRank = 1;
    localeIdArray->minimumSamplingInterval = 1.0;
    UA_Server_addNode(server, (UA_Node*)localeIdArray,
@@ -880,9 +880,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
     copyNames((UA_Node*)maxBrowseContinuationPoints, "MaxBrowseContinuationPoints");
     maxBrowseContinuationPoints->nodeId.identifier.numeric =
         UA_NS0ID_SERVER_SERVERCAPABILITIES_MAXBROWSECONTINUATIONPOINTS;
-    maxBrowseContinuationPoints->value.variant.data = UA_UInt16_new();
-    *((UA_UInt16*)maxBrowseContinuationPoints->value.variant.data) = MAXCONTINUATIONPOINTS;
-    maxBrowseContinuationPoints->value.variant.type = &UA_TYPES[UA_TYPES_UINT16];
+    maxBrowseContinuationPoints->value.variantAndCallback.variant.data = UA_UInt16_new();
+    *((UA_UInt16*)maxBrowseContinuationPoints->value.variantAndCallback.variant.data) = MAXCONTINUATIONPOINTS;
+    maxBrowseContinuationPoints->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_UINT16];
     UA_Server_addNode(server, (UA_Node*)maxBrowseContinuationPoints,
                       UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERCAPABILITIES), nodeIdHasProperty);
     UA_Server_addReference(server,
@@ -909,11 +909,11 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
     UA_VariableNode *serverProfileArray = UA_VariableNode_new();
     copyNames((UA_Node*)serverProfileArray, "ServerProfileArray");
     serverProfileArray->nodeId.identifier.numeric = UA_NS0ID_SERVER_SERVERCAPABILITIES_SERVERPROFILEARRAY;
-    serverProfileArray->value.variant.arrayLength = profileArraySize;
-    serverProfileArray->value.variant.data = UA_Array_new(&UA_TYPES[UA_TYPES_STRING], profileArraySize);
-    serverProfileArray->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
+    serverProfileArray->value.variantAndCallback.variant.arrayLength = profileArraySize;
+    serverProfileArray->value.variantAndCallback.variant.data = UA_Array_new(&UA_TYPES[UA_TYPES_STRING], profileArraySize);
+    serverProfileArray->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
     for(UA_UInt16 i=0;i<profileArraySize;i++){
-        ((UA_String *)serverProfileArray->value.variant.data)[i] = profileArray[i];
+        ((UA_String *)serverProfileArray->value.variantAndCallback.variant.data)[i] = profileArray[i];
     }
     serverProfileArray->valueRank = 1;
     serverProfileArray->minimumSamplingInterval = 1.0;
@@ -934,8 +934,8 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
     UA_VariableNode *enabledFlag = UA_VariableNode_new();
      copyNames((UA_Node*)enabledFlag, "EnabledFlag");
      enabledFlag->nodeId.identifier.numeric = UA_NS0ID_SERVER_SERVERDIAGNOSTICS_ENABLEDFLAG;
-     enabledFlag->value.variant.data = UA_Boolean_new(); //initialized as false
-     enabledFlag->value.variant.type = &UA_TYPES[UA_TYPES_BOOLEAN];
+     enabledFlag->value.variantAndCallback.variant.data = UA_Boolean_new(); //initialized as false
+     enabledFlag->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_BOOLEAN];
      enabledFlag->valueRank = 1;
      enabledFlag->minimumSamplingInterval = 1.0;
      UA_Server_addNode(server, (UA_Node*)enabledFlag,
@@ -956,9 +956,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
      UA_VariableNode *starttime = UA_VariableNode_new();
       copyNames((UA_Node*)starttime, "StartTime");
       starttime->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_STARTTIME);
-      starttime->value.variant.storageType = UA_VARIANT_DATA_NODELETE;
-      starttime->value.variant.data = &server->startTime;
-      starttime->value.variant.type = &UA_TYPES[UA_TYPES_DATETIME];
+      starttime->value.variantAndCallback.variant.storageType = UA_VARIANT_DATA_NODELETE;
+      starttime->value.variantAndCallback.variant.data = &server->startTime;
+      starttime->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_DATETIME];
       UA_Server_addNode(server, (UA_Node*)starttime, UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS),
                         nodeIdHasComponent);
       UA_Server_addReference(server, UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_STARTTIME),
@@ -980,9 +980,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
       *stateEnum = UA_SERVERSTATE_RUNNING;
       copyNames((UA_Node*)state, "State");
       state->nodeId.identifier.numeric = UA_NS0ID_SERVER_SERVERSTATUS_STATE;
-      state->value.variant.type = &UA_TYPES[UA_TYPES_SERVERSTATE];
-      state->value.variant.arrayLength = -1;
-      state->value.variant.data = stateEnum; // points into the other object.
+      state->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_SERVERSTATE];
+      state->value.variantAndCallback.variant.arrayLength = -1;
+      state->value.variantAndCallback.variant.data = stateEnum; // points into the other object.
       UA_Server_addNode(server, (UA_Node*)state, UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS),
                         nodeIdHasComponent);
       UA_Server_addReference(server, UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_STATE),
@@ -991,9 +991,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
       UA_VariableNode *buildinfo = UA_VariableNode_new();
        copyNames((UA_Node*)buildinfo, "BuildInfo");
        buildinfo->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO);
-       buildinfo->value.variant.data = UA_BuildInfo_new();
-       buildinfo->value.variant.type = &UA_TYPES[UA_TYPES_BUILDINFO];
-       getBulidInfo(server, (UA_BuildInfo*)buildinfo->value.variant.data);
+       buildinfo->value.variantAndCallback.variant.data = UA_BuildInfo_new();
+       buildinfo->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_BUILDINFO];
+       getBulidInfo(server, (UA_BuildInfo*)buildinfo->value.variantAndCallback.variant.data);
        UA_Server_addNode(server, (UA_Node*)buildinfo,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS),
                          nodeIdHasComponent);
@@ -1003,9 +1003,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *producturi = UA_VariableNode_new();
        copyNames((UA_Node*)producturi, "ProductUri");
        producturi->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO_PRODUCTURI);
-       producturi->value.variant.data = UA_String_new();
-       *((UA_String*)producturi->value.variant.data) = UA_STRING_ALLOC(PRODUCT_URI);
-       producturi->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
+       producturi->value.variantAndCallback.variant.data = UA_String_new();
+       *((UA_String*)producturi->value.variantAndCallback.variant.data) = UA_STRING_ALLOC(PRODUCT_URI);
+       producturi->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
        UA_Server_addNode(server, (UA_Node*)producturi,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO),
                          nodeIdHasComponent);
@@ -1015,9 +1015,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *manufacturername = UA_VariableNode_new();
        copyNames((UA_Node*)manufacturername, "ManufacturererName");
        manufacturername->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO_MANUFACTURERNAME);
-       manufacturername->value.variant.data = UA_String_new();
-       *((UA_String*)manufacturername->value.variant.data) = UA_STRING_ALLOC(MANUFACTURER_NAME);
-       manufacturername->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
+       manufacturername->value.variantAndCallback.variant.data = UA_String_new();
+       *((UA_String*)manufacturername->value.variantAndCallback.variant.data) = UA_STRING_ALLOC(MANUFACTURER_NAME);
+       manufacturername->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
        UA_Server_addNode(server, (UA_Node*)manufacturername,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO),
                          nodeIdHasComponent);
@@ -1028,9 +1028,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *productname = UA_VariableNode_new();
        copyNames((UA_Node*)productname, "ProductName");
        productname->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO_PRODUCTNAME);
-       productname->value.variant.data = UA_String_new();
-       *((UA_String*)productname->value.variant.data) = UA_STRING_ALLOC(PRODUCT_NAME);
-       productname->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
+       productname->value.variantAndCallback.variant.data = UA_String_new();
+       *((UA_String*)productname->value.variantAndCallback.variant.data) = UA_STRING_ALLOC(PRODUCT_NAME);
+       productname->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
        UA_Server_addNode(server, (UA_Node*)productname,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO),
                          nodeIdHasComponent);
@@ -1040,9 +1040,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *softwareversion = UA_VariableNode_new();
        copyNames((UA_Node*)softwareversion, "SoftwareVersion");
        softwareversion->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO_SOFTWAREVERSION);
-       softwareversion->value.variant.data = UA_String_new();
-       *((UA_String*)softwareversion->value.variant.data) = UA_STRING_ALLOC(SOFTWARE_VERSION);
-       softwareversion->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
+       softwareversion->value.variantAndCallback.variant.data = UA_String_new();
+       *((UA_String*)softwareversion->value.variantAndCallback.variant.data) = UA_STRING_ALLOC(SOFTWARE_VERSION);
+       softwareversion->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
        UA_Server_addNode(server, (UA_Node*)softwareversion,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO),
                          nodeIdHasComponent);
@@ -1053,9 +1053,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *buildnumber = UA_VariableNode_new();
        copyNames((UA_Node*)buildnumber, "BuildNumber");
        buildnumber->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO_BUILDNUMBER);
-       buildnumber->value.variant.data = UA_String_new();
-       *((UA_String*)buildnumber->value.variant.data) = UA_STRING_ALLOC(BUILD_NUMBER);
-       buildnumber->value.variant.type = &UA_TYPES[UA_TYPES_STRING];
+       buildnumber->value.variantAndCallback.variant.data = UA_String_new();
+       *((UA_String*)buildnumber->value.variantAndCallback.variant.data) = UA_STRING_ALLOC(BUILD_NUMBER);
+       buildnumber->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_STRING];
        UA_Server_addNode(server, (UA_Node*)buildnumber,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO),
                          nodeIdHasComponent);
@@ -1065,9 +1065,9 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *builddate = UA_VariableNode_new();
        copyNames((UA_Node*)builddate, "BuildDate");
        builddate->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO_BUILDDATE);
-       builddate->value.variant.storageType = UA_VARIANT_DATA_NODELETE;
-       builddate->value.variant.data = &server->buildDate;
-       builddate->value.variant.type = &UA_TYPES[UA_TYPES_DATETIME];
+       builddate->value.variantAndCallback.variant.storageType = UA_VARIANT_DATA_NODELETE;
+       builddate->value.variantAndCallback.variant.data = &server->buildDate;
+       builddate->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_DATETIME];
        UA_Server_addNode(server, (UA_Node*)builddate,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_BUILDINFO),
                          nodeIdHasComponent);
@@ -1077,8 +1077,8 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *secondstillshutdown = UA_VariableNode_new();
        copyNames((UA_Node*)secondstillshutdown, "SecondsTillShutdown");
        secondstillshutdown->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_SECONDSTILLSHUTDOWN);
-       secondstillshutdown->value.variant.data = UA_UInt32_new();
-       secondstillshutdown->value.variant.type = &UA_TYPES[UA_TYPES_UINT32];
+       secondstillshutdown->value.variantAndCallback.variant.data = UA_UInt32_new();
+       secondstillshutdown->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_UINT32];
        UA_Server_addNode(server, (UA_Node*)secondstillshutdown,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS), nodeIdHasComponent);
        UA_Server_addReference(server, UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_SECONDSTILLSHUTDOWN),
@@ -1087,8 +1087,8 @@ UA_Server * UA_Server_new(UA_ServerConfig config) {
        UA_VariableNode *shutdownreason = UA_VariableNode_new();
        copyNames((UA_Node*)shutdownreason, "ShutdownReason");
        shutdownreason->nodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_SHUTDOWNREASON);
-       shutdownreason->value.variant.data = UA_LocalizedText_new();
-       shutdownreason->value.variant.type = &UA_TYPES[UA_TYPES_LOCALIZEDTEXT];
+       shutdownreason->value.variantAndCallback.variant.data = UA_LocalizedText_new();
+       shutdownreason->value.variantAndCallback.variant.type = &UA_TYPES[UA_TYPES_LOCALIZEDTEXT];
        UA_Server_addNode(server, (UA_Node*)shutdownreason,
                          UA_EXPANDEDNODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS), nodeIdHasComponent);
        UA_Server_addReference(server, UA_NODEID_NUMERIC(0, UA_NS0ID_SERVER_SERVERSTATUS_SHUTDOWNREASON),
diff --git a/src/server/ua_server_addressspace.c b/src/server/ua_server_addressspace.c
index 6597dde57c6..34c4bbdddcc 100644
--- a/src/server/ua_server_addressspace.c
+++ b/src/server/ua_server_addressspace.c
@@ -155,7 +155,7 @@ UA_Server_addVariableNode(UA_Server *server, const UA_NodeId nodeId, const UA_Qu
                           UA_NodeId *createdNodeId) {
     UA_VariableNode *node = UA_VariableNode_new();
     UA_StatusCode retval;
-    node->value.variant = *value; // copy content
+    node->value.variantAndCallback.variant = *value; // copy content
     UA_NodeId_copy(&nodeId, &node->nodeId);
     UA_QualifiedName_copy(&browseName, &node->browseName);
     UA_LocalizedText_copy(&displayName, &node->displayName);
@@ -171,7 +171,7 @@ UA_Server_addVariableNode(UA_Server *server, const UA_NodeId nodeId, const UA_Qu
                            UA_EXPANDEDNODEID_NUMERIC(0, value->type->typeId.identifier.numeric));
     
     if(res.statusCode != UA_STATUSCODE_GOOD) {
-        UA_Variant_init(&node->value.variant);
+        UA_Variant_init(&node->value.variantAndCallback.variant);
         UA_VariableNode_delete(node);
     } else 
         UA_free(value);
@@ -271,7 +271,7 @@ UA_Server_addVariableTypeNode(UA_Server *server, const UA_NodeId nodeId, const U
         UA_NodeId *createdNodeId) {
     UA_VariableTypeNode *node = UA_VariableTypeNode_new();
     UA_StatusCode retval;
-    node->value.variant = *value; // copy content
+    node->value.variantAndCallback.variant = *value; // copy content
     UA_NodeId_copy(&nodeId, &node->nodeId);
     UA_QualifiedName_copy(&browseName, &node->browseName);
     UA_LocalizedText_copy(&displayName, &node->displayName);
@@ -289,7 +289,7 @@ UA_Server_addVariableTypeNode(UA_Server *server, const UA_NodeId nodeId, const U
                            UA_EXPANDEDNODEID_NUMERIC(0, value->type->typeId.identifier.numeric));
     
     if(res.statusCode != UA_STATUSCODE_GOOD) {
-        UA_Variant_init(&node->value.variant);
+        UA_Variant_init(&node->value.variantAndCallback.variant);
         UA_VariableTypeNode_delete(node);
     } else 
         UA_free(value);
@@ -857,7 +857,7 @@ UA_Server_addMethodNode(UA_Server* server, const UA_NodeId nodeId, const UA_Qual
     inputArgumentsVariableNode->displayName = UA_LOCALIZEDTEXT_ALLOC("en_US", "InputArguments");
     inputArgumentsVariableNode->description = UA_LOCALIZEDTEXT_ALLOC("en_US", "InputArguments");
     inputArgumentsVariableNode->valueRank = 1;
-    UA_Variant_setArrayCopy(&inputArgumentsVariableNode->value.variant, inputArguments,
+    UA_Variant_setArrayCopy(&inputArgumentsVariableNode->value.variantAndCallback.variant, inputArguments,
                             inputArgumentsSize, &UA_TYPES[UA_TYPES_ARGUMENT]);
     addRes = UA_Server_addNode(server, (UA_Node*)inputArgumentsVariableNode, methodExpandedNodeId,
                                UA_NODEID_NUMERIC(0, UA_NS0ID_HASPROPERTY));
@@ -878,7 +878,7 @@ UA_Server_addMethodNode(UA_Server* server, const UA_NodeId nodeId, const UA_Qual
     outputArgumentsVariableNode->displayName = UA_LOCALIZEDTEXT_ALLOC("en_US", "OutputArguments");
     outputArgumentsVariableNode->description = UA_LOCALIZEDTEXT_ALLOC("en_US", "OutputArguments");
     outputArgumentsVariableNode->valueRank = 1;
-    UA_Variant_setArrayCopy(&outputArgumentsVariableNode->value.variant, outputArguments,
+    UA_Variant_setArrayCopy(&outputArgumentsVariableNode->value.variantAndCallback.variant, outputArguments,
                             outputArgumentsSize, &UA_TYPES[UA_TYPES_ARGUMENT]);
     addRes = UA_Server_addNode(server, (UA_Node*)outputArgumentsVariableNode, methodExpandedNodeId,
                                UA_NODEID_NUMERIC(0, UA_NS0ID_HASPROPERTY));
@@ -1025,8 +1025,8 @@ UA_StatusCode UA_Server_setAttributeValue(UA_Server *server, UA_NodeId nodeId, U
         return UA_STATUSCODE_BADATTRIBUTEIDINVALID;
       }
       nVariant = value;
-      UA_Variant_deleteMembers(&anyTypeNode.vObj->value.variant);
-      UA_Variant_copy(nVariant, &anyTypeNode.vObj->value.variant);
+      UA_Variant_deleteMembers(&anyTypeNode.vObj->value.variantAndCallback.variant);
+      UA_Variant_copy(nVariant, &anyTypeNode.vObj->value.variantAndCallback.variant);
       break;
     case UA_ATTRIBUTEID_DATATYPE:
       UA_Server_deleteNodeCopy(server, (void **) &anyTypeNode.node);
@@ -1123,7 +1123,7 @@ UA_Server_setAttribute_method(UA_Server *server, UA_NodeId methodNodeId, UA_Meth
 #endif
 
 UA_StatusCode
-UA_Server_setAttribute_DataSource(UA_Server *server, UA_NodeId nodeId, UA_DataSource *value) {
+UA_Server_setAttribute_DataSource(UA_Server *server, UA_NodeId nodeId, UA_DataSource value) {
   union {
     UA_Node *anyNode;
     UA_VariableNode *varNode;
@@ -1142,21 +1142,18 @@ UA_Server_setAttribute_DataSource(UA_Server *server, UA_NodeId nodeId, UA_DataSo
   
   if (node.anyNode->nodeClass == UA_NODECLASS_VARIABLE) {
     if (node.varNode->valueSource == UA_VALUESOURCE_VARIANT) {
-      UA_Variant_deleteMembers(&node.varNode->value.variant);
+      UA_Variant_deleteMembers(&node.varNode->value.variantAndCallback.variant);
     }
     node.varNode->valueSource = UA_VALUESOURCE_DATASOURCE;
-    node.varNode->value.dataSource.handle = value->handle;
-    node.varNode->value.dataSource.read   = value->read;
-    node.varNode->value.dataSource.write  = value->write;
+    node.varNode->value.dataSource = value;
   }
+  //UA_NODECLASS_VARIABLE_TYPE
   else {
     if (node.varTNode->valueSource == UA_VALUESOURCE_VARIANT) {
-      UA_Variant_deleteMembers(&node.varTNode->value.variant);
+      UA_Variant_deleteMembers(&node.varTNode->value.variantAndCallback.variant);
     }
     node.varTNode->valueSource = UA_VALUESOURCE_DATASOURCE;
-    node.varTNode->value.dataSource.handle = value->handle;
-    node.varTNode->value.dataSource.read   = value->read;
-    node.varTNode->value.dataSource.write  = value->write;
+    node.varTNode->value.dataSource = value;
   }
   
   const UA_Node **inserted = UA_NULL;
@@ -1167,6 +1164,44 @@ UA_Server_setAttribute_DataSource(UA_Server *server, UA_NodeId nodeId, UA_DataSo
   return retval;
 }
 
+UA_StatusCode
+UA_Server_setAttribute_UserspaceCallback(UA_Server *server, UA_NodeId nodeId, UA_UserspaceCallback value) {
+  union {
+    UA_Node *anyNode;
+    UA_VariableNode *varNode;
+    UA_VariableTypeNode *varTNode;
+  } node;
+  UA_StatusCode retval;
+  retval = UA_Server_getNodeCopy(server, nodeId, (void **) &node.anyNode);
+
+  if (retval != UA_STATUSCODE_GOOD || node.anyNode == UA_NULL)
+    return retval;
+
+  if (node.anyNode->nodeClass != UA_NODECLASS_VARIABLE && node.anyNode->nodeClass != UA_NODECLASS_VARIABLETYPE) {
+    UA_Server_deleteNodeCopy(server, (void **) &node);
+    return UA_STATUSCODE_BADNODECLASSINVALID;
+  }
+
+  if(node.varNode->valueSource == UA_VALUESOURCE_DATASOURCE){
+    return UA_STATUSCODE_BADNODECLASSINVALID;
+  }
+
+  if (node.anyNode->nodeClass == UA_NODECLASS_VARIABLE) {
+    node.varNode->value.variantAndCallback.callback = value;
+  }
+  //UA_NODECLASS_VARIABLE_TYPE
+  else {
+      node.varTNode->value.variantAndCallback.callback = value;
+  }
+
+  const UA_Node **inserted = UA_NULL;
+  const UA_Node *oldNode = UA_NodeStore_get(server->nodestore, &node.anyNode->nodeId);
+  retval |= UA_NodeStore_replace(server->nodestore, oldNode, node.anyNode, inserted);
+  UA_NodeStore_release(oldNode);
+
+  return retval;
+}
+
 #define SERVER_GETATTRIBUTE_COPYTYPEVALUE(TYPE, SRC) \
   *value = (void *) UA_##TYPE##_new();               \
   UA_##TYPE##_copy( SRC, (UA_##TYPE *) *value  );    \
@@ -1264,7 +1299,9 @@ UA_StatusCode UA_Server_getAttributeValue(UA_Server *server, UA_NodeId nodeId, U
         case UA_NODECLASS_VARIABLE:
           *value = UA_Variant_new();
           if(anyTypeNode.vObj->valueSource == UA_VALUESOURCE_VARIANT) {
-            retval |= UA_Variant_copy(&anyTypeNode.vObj->value.variant, *value);
+            retval |= UA_Variant_copy(&anyTypeNode.vObj->value.variantAndCallback.variant, *value);
+            if(anyTypeNode.vObj->value.variantAndCallback.callback.onRead)
+                anyTypeNode.vObj->value.variantAndCallback.callback.onRead(anyTypeNode.vObj->value.variantAndCallback.callback.handle, nodeId, *value, UA_NULL);
           } else {
             UA_DataValue ds;
             UA_DataValue_init(&ds);
@@ -1276,7 +1313,9 @@ UA_StatusCode UA_Server_getAttributeValue(UA_Server *server, UA_NodeId nodeId, U
           // Note: Precicely the same as variableNode above!
           *value = UA_Variant_new();
           if(anyTypeNode.vtObj->valueSource == UA_VALUESOURCE_VARIANT) {
-            retval |= UA_Variant_copy(&anyTypeNode.vtObj->value.variant, *value);
+            retval |= UA_Variant_copy(&anyTypeNode.vtObj->value.variantAndCallback.variant, *value);
+            if(anyTypeNode.vtObj->value.variantAndCallback.callback.onRead)
+                anyTypeNode.vtObj->value.variantAndCallback.callback.onRead(anyTypeNode.vtObj->value.variantAndCallback.callback.handle, nodeId, *value, UA_NULL);
           } else {
             UA_DataValue ds;
             UA_DataValue_init(&ds);
@@ -1558,8 +1597,10 @@ void UA_Server_addInstanceOf_instatiateChildNode(UA_Server *server,
         newVarNode->valueSource = varTypeNode->valueSource;
         if (varTypeNode->valueSource == UA_VALUESOURCE_DATASOURCE)
           newVarNode->value.dataSource = varTypeNode->value.dataSource;
-        else
-          UA_Variant_copy(&varTypeNode->value.variant, &newVarNode->value.variant);
+        else{
+          newVarNode->value.variantAndCallback.callback = varTypeNode->value.variantAndCallback.callback;
+          UA_Variant_copy(&varTypeNode->value.variantAndCallback.variant, &newVarNode->value.variantAndCallback.variant);
+        }
         
         adres = UA_Server_addNode(server, (UA_Node *) newVarNode, *objectRootExpanded, ref.referenceTypeId);
         if (callback != UA_NULL)
diff --git a/src/server/ua_services_attribute.c b/src/server/ua_services_attribute.c
index ed9375d4361..c1915cc24f6 100644
--- a/src/server/ua_services_attribute.c
+++ b/src/server/ua_services_attribute.c
@@ -210,15 +210,18 @@ void readValue(UA_Server *server, UA_TimestampsToReturn timestamps, const UA_Rea
             }
 
             const UA_VariableNode *vn = (const UA_VariableNode*)node;
+
             if(vn->valueSource == UA_VALUESOURCE_VARIANT) {
                 if(rangeptr)
-                    retval |= UA_Variant_copyRange(&vn->value.variant, &v->value, range);
+                    retval |= UA_Variant_copyRange(&vn->value.variantAndCallback.variant, &v->value, range);
                 else
-                    retval |= UA_Variant_copy(&vn->value.variant, &v->value);
+                    retval |= UA_Variant_copy(&vn->value.variantAndCallback.variant, &v->value);
                 if(retval == UA_STATUSCODE_GOOD) {
                     v->hasValue = UA_TRUE;
                     handleSourceTimestamps(timestamps, v);
                 }
+                if(vn->value.variantAndCallback.callback.onRead)
+                    vn->value.variantAndCallback.callback.onRead(vn->value.variantAndCallback.callback.handle, vn->nodeId, &v->value, rangeptr);
             } else {
                 UA_Boolean sourceTimeStamp = (timestamps == UA_TIMESTAMPSTORETURN_SOURCE || timestamps == UA_TIMESTAMPSTORETURN_BOTH);
                 retval |= vn->value.dataSource.read(vn->value.dataSource.handle, vn->nodeId, sourceTimeStamp, rangeptr, v);
@@ -232,9 +235,11 @@ void readValue(UA_Server *server, UA_TimestampsToReturn timestamps, const UA_Rea
     case UA_ATTRIBUTEID_DATATYPE: {
 		CHECK_NODECLASS(UA_NODECLASS_VARIABLE | UA_NODECLASS_VARIABLETYPE);
         const UA_VariableNode *vn = (const UA_VariableNode*)node;
-        if(vn->valueSource == UA_VALUESOURCE_VARIANT)
-            retval = UA_Variant_setScalarCopy(&v->value, &vn->value.variant.type->typeId, &UA_TYPES[UA_TYPES_NODEID]);
-        else {
+        if(vn->valueSource == UA_VALUESOURCE_VARIANT){
+            retval = UA_Variant_setScalarCopy(&v->value, &vn->value.variantAndCallback.variant.type->typeId, &UA_TYPES[UA_TYPES_NODEID]);
+            if(vn->value.variantAndCallback.callback.onRead)
+                vn->value.variantAndCallback.callback.onRead(vn->value.variantAndCallback.callback.handle, vn->nodeId, &vn->value.variantAndCallback.variant, UA_NULL);
+        } else {
             UA_DataValue val;
             UA_DataValue_init(&val);
             retval = vn->value.dataSource.read(vn->value.dataSource.handle, vn->nodeId, UA_FALSE, UA_NULL, &val);
@@ -260,7 +265,7 @@ void readValue(UA_Server *server, UA_TimestampsToReturn timestamps, const UA_Rea
         {
             const UA_VariableNode *vn = (const UA_VariableNode *)node;
             if(vn->valueSource == UA_VALUESOURCE_VARIANT) {
-                retval = UA_Variant_setArrayCopy(&v->value, vn->value.variant.arrayDimensions, vn->value.variant.arrayDimensionsSize, &UA_TYPES[UA_TYPES_INT32]);
+                retval = UA_Variant_setArrayCopy(&v->value, vn->value.variantAndCallback.variant.arrayDimensions, vn->value.variantAndCallback.variant.arrayDimensionsSize, &UA_TYPES[UA_TYPES_INT32]);
                 if(retval == UA_STATUSCODE_GOOD)
                     v->hasValue = UA_TRUE;
             } else {
@@ -559,7 +564,7 @@ UA_StatusCode writeValue(UA_Server *server, UA_WriteValue *wvalue) {
                 done = UA_TRUE;
                 goto clean_up_range;
             }
-            const UA_Variant *oldV = &vn->value.variant;
+            const UA_Variant *oldV = &vn->value.variantAndCallback.variant;
 
             /* the nodeid on the wire may be != the nodeid in the node: opaque types, enums and bytestrings */
             if(!UA_NodeId_equal(&oldV->type->typeId, &wvalue->value.value.type->typeId)) {
@@ -598,15 +603,23 @@ UA_StatusCode writeValue(UA_Server *server, UA_WriteValue *wvalue) {
                 
             /* insert the new value */
             if(hasRange)
-                retval = UA_Variant_setRangeCopy(&newVn->value.variant, wvalue->value.value.data,
+                retval = UA_Variant_setRangeCopy(&newVn->value.variantAndCallback.variant, wvalue->value.value.data,
                                                  wvalue->value.value.arrayLength, range);
             else {
-                UA_Variant_deleteMembers(&newVn->value.variant);
-                retval = UA_Variant_copy(&wvalue->value.value, &newVn->value.variant);
+                UA_Variant_deleteMembers(&newVn->value.variantAndCallback.variant);
+                retval = UA_Variant_copy(&wvalue->value.value, &newVn->value.variantAndCallback.variant);
             }
 
             if(retval == UA_STATUSCODE_GOOD && UA_NodeStore_replace(server->nodestore, node,
                                                    (UA_Node*)newVn, UA_NULL) == UA_STATUSCODE_GOOD) {
+                //trigger onWrite
+                if(vn->value.variantAndCallback.callback.onWrite){
+                    if(hasRange)
+                        vn->value.variantAndCallback.callback.onWrite(vn->value.variantAndCallback.callback.handle, wvalue->nodeId, &wvalue->value.value, &range);
+                    else
+                        vn->value.variantAndCallback.callback.onWrite(vn->value.variantAndCallback.callback.handle, wvalue->nodeId, &wvalue->value.value, UA_NULL);
+                }
+
                 done = UA_TRUE;
                 goto clean_up_range;
             }
diff --git a/src/server/ua_services_call.c b/src/server/ua_services_call.c
index 3f1aeb73bde..612d7d95bfe 100644
--- a/src/server/ua_services_call.c
+++ b/src/server/ua_services_call.c
@@ -73,12 +73,12 @@ static UA_StatusCode statisfySignature(UA_Variant *var, UA_Argument arg) {
 }
 
 static UA_StatusCode argConformsToDefinition(UA_CallMethodRequest *rs, const UA_VariableNode *argDefinition) {
-    if(argDefinition->value.variant.type != &UA_TYPES[UA_TYPES_ARGUMENT] &&
-        argDefinition->value.variant.type != &UA_TYPES[UA_TYPES_EXTENSIONOBJECT])
+    if(argDefinition->value.variantAndCallback.variant.type != &UA_TYPES[UA_TYPES_ARGUMENT] &&
+        argDefinition->value.variantAndCallback.variant.type != &UA_TYPES[UA_TYPES_EXTENSIONOBJECT])
         return UA_STATUSCODE_BADINTERNALERROR;
-    if(rs->inputArgumentsSize < argDefinition->value.variant.arrayLength) 
+    if(rs->inputArgumentsSize < argDefinition->value.variantAndCallback.variant.arrayLength)
         return UA_STATUSCODE_BADARGUMENTSMISSING;
-    if(rs->inputArgumentsSize > argDefinition->value.variant.arrayLength)
+    if(rs->inputArgumentsSize > argDefinition->value.variantAndCallback.variant.arrayLength)
         return UA_STATUSCODE_BADINVALIDARGUMENT;
     
     const UA_ExtensionObject *thisArgDefExtObj;
@@ -89,16 +89,16 @@ static UA_StatusCode argConformsToDefinition(UA_CallMethodRequest *rs, const UA_
     UA_NodeId ArgumentNodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_ARGUMENT + UA_ENCODINGOFFSET_BINARY);
     for(int i = 0; i<rs->inputArgumentsSize; i++) {
         var = &rs->inputArguments[i];
-        if(argDefinition->value.variant.type == &UA_TYPES[UA_TYPES_EXTENSIONOBJECT]) {
-            thisArgDefExtObj = &((const UA_ExtensionObject *) (argDefinition->value.variant.data))[i];
+        if(argDefinition->value.variantAndCallback.variant.type == &UA_TYPES[UA_TYPES_EXTENSIONOBJECT]) {
+            thisArgDefExtObj = &((const UA_ExtensionObject *) (argDefinition->value.variantAndCallback.variant.data))[i];
             decodingOffset = 0;
             
             if(!UA_NodeId_equal(&ArgumentNodeId, &thisArgDefExtObj->typeId))
                 return UA_STATUSCODE_BADINTERNALERROR;
                 
             UA_decodeBinary(&thisArgDefExtObj->body, &decodingOffset, &arg, &UA_TYPES[UA_TYPES_ARGUMENT]);
-        } else if(argDefinition->value.variant.type == &UA_TYPES[UA_TYPES_ARGUMENT])
-            arg = ((UA_Argument *) argDefinition->value.variant.data)[i];
+        } else if(argDefinition->value.variantAndCallback.variant.type == &UA_TYPES[UA_TYPES_ARGUMENT])
+            arg = ((UA_Argument *) argDefinition->value.variantAndCallback.variant.data)[i];
         retval |= statisfySignature(var, arg);
     }
     return retval;
@@ -178,8 +178,8 @@ static void callMethod(UA_Server *server, UA_Session *session, UA_CallMethodRequ
     // Call method if available
     if(methodCalled->attachedMethod) {
         result->outputArguments = UA_Array_new(&UA_TYPES[UA_TYPES_VARIANT],
-                                               outputArguments->value.variant.arrayLength);
-        result->outputArgumentsSize = outputArguments->value.variant.arrayLength;
+                                               outputArguments->value.variantAndCallback.variant.arrayLength);
+        result->outputArgumentsSize = outputArguments->value.variantAndCallback.variant.arrayLength;
         result->statusCode = methodCalled->attachedMethod(withObject->nodeId, request->inputArguments,
                                                           result->outputArguments, methodCalled->methodHandle);
     }
diff --git a/src/server/ua_services_nodemanagement.c b/src/server/ua_services_nodemanagement.c
index 443a3c4e540..65ea50eadb1 100644
--- a/src/server/ua_services_nodemanagement.c
+++ b/src/server/ua_services_nodemanagement.c
@@ -67,7 +67,7 @@ static UA_StatusCode parseVariableNode(UA_ExtensionObject *attributes, UA_Node *
     /* } */
 
     if(attr.specifiedAttributes & UA_NODEATTRIBUTESMASK_VALUE) {
-        vnode->value.variant = attr.value;
+        vnode->value.variantAndCallback.variant = attr.value;
         UA_Variant_init(&attr.value);
     }
 
diff --git a/src/server/ua_subscription.c b/src/server/ua_subscription.c
index 1c6b399608e..a8fdb397ac2 100644
--- a/src/server/ua_subscription.c
+++ b/src/server/ua_subscription.c
@@ -426,7 +426,8 @@ UA_Boolean MonitoredItem_CopyMonitoredValueToVariant(UA_UInt32 attributeID, cons
         if(src->nodeClass == UA_NODECLASS_VARIABLE) {
             const UA_VariableNode *vsrc = (const UA_VariableNode*)src;
             if(srcAsVariableNode->valueSource == UA_VALUESOURCE_VARIANT) {
-                UA_Variant_copy(&vsrc->value.variant, dst);
+                UA_Variant_copy(&vsrc->value.variantAndCallback.variant, dst);
+                //no onRead callback here since triggered by a subscription
                 samplingError = UA_FALSE;
             } else {
                 if(srcAsVariableNode->valueSource != UA_VALUESOURCE_DATASOURCE)
diff --git a/tests/check_services_attributes.c b/tests/check_services_attributes.c
index 09a0931850b..cd50cfd1dae 100644
--- a/tests/check_services_attributes.c
+++ b/tests/check_services_attributes.c
@@ -88,7 +88,7 @@ static UA_VariableNode* makeCompareSequence(void) {
         const UA_NodeId myIntegerNodeId = UA_NODEID_STRING(1, "the.answer");
 	UA_NodeId parentNodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_OBJECTSFOLDER);
 	//UA_NodeId parentReferenceNodeId = UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES);
-	node->value.variant=*myIntegerVariant;
+	node->value.variantAndCallback.variant=*myIntegerVariant;
 	UA_NodeId_copy(&myIntegerNodeId,&node->nodeId);
 	UA_QualifiedName_copy(&myIntegerName,&node->browseName);
         UA_LocalizedText_copy(&myIntegerDisplName, &node->displayName);
@@ -851,7 +851,7 @@ START_TEST(WriteSingleAttributeValue)
 		const UA_Node *node = UA_NodeStore_get(server->nodestore, &wValue.nodeId);
 		ck_assert_int_eq(node->nodeClass, UA_NODECLASS_VARIABLE);
 		const UA_VariableNode *vn = (const UA_VariableNode*)node;
-		const UA_Variant *oldV = &vn->value.variant;
+		const UA_Variant *oldV = &vn->value.variantAndCallback.variant;
 		ck_assert_ptr_eq(&oldV->type->typeId, &wValue.value.value.type->typeId);
 
 		ck_assert_int_eq(20, *(UA_Int32* )resp.value.data);
diff --git a/tools/pyUANamespace/ua_builtin_types.py b/tools/pyUANamespace/ua_builtin_types.py
index 4558f28841f..eefc33509d1 100644
--- a/tools/pyUANamespace/ua_builtin_types.py
+++ b/tools/pyUANamespace/ua_builtin_types.py
@@ -367,7 +367,7 @@ def printOpen62541CCode(self, bootstrapping = True):
         code.append("UA_Variant_setArrayCopy(" + self.parent.getCodePrintableID() + "_variant, &" + valueName + ", (UA_Int32) " + str(len(self.value)) + ", &UA_TYPES[UA_TYPES_" + self.value[0].stringRepresentation.upper() + "]);")
         # Variant creation is now part of printSubtypeEarly, the node does not exist when the type is initialized!
         #if (bootstrapping == True):
-        #  code.append(self.parent.getCodePrintableID() + "->value.variant = *" + self.parent.getCodePrintableID() + "_variant;")
+        #  code.append(self.parent.getCodePrintableID() + "->value.variantAndCallback.variant = *" + self.parent.getCodePrintableID() + "_variant;")
     else:
       # User the following strategy for all directly mappable values a la 'UA_Type MyInt = (UA_Type) 23;'
       if self.value[0].__binTypeId__ == BUILTINTYPE_TYPEID_GUID:
@@ -391,14 +391,14 @@ def printOpen62541CCode(self, bootstrapping = True):
           code.append("UA_" + self.value[0].stringRepresentation + "_deleteMembers(" + valueName + ");")
           # Variant creation is now part of printSubtypeEarly, the node does not exist when the type is initialized!
           #if (bootstrapping == True):
-          #  code.append(self.parent.getCodePrintableID() + "->value.variant = *" + self.parent.getCodePrintableID() + "_variant;")
+          #  code.append(self.parent.getCodePrintableID() + "->value.variantAndCallback.variant = *" + self.parent.getCodePrintableID() + "_variant;")
         else:
           code.append("UA_" + self.value[0].stringRepresentation + " " + valueName + " = " + self.value[0].printOpen62541CCode_SubType() + ";")
           code.append("UA_Variant_setScalarCopy(" + self.parent.getCodePrintableID() + "_variant, &" + valueName + ", &UA_TYPES[UA_TYPES_" + self.value[0].stringRepresentation.upper() + "]);")
           code.append("UA_" + self.value[0].stringRepresentation + "_deleteMembers(&" + valueName + ");")
           # Variant creation is now part of printSubtypeEarly, the node does not exist when the type is initialized!
           #if (bootstrapping == True):
-          #  code.append(self.parent.getCodePrintableID() + "->value.variant = *" + self.parent.getCodePrintableID() + "_variant;")
+          #  code.append(self.parent.getCodePrintableID() + "->value.variantAndCallback.variant = *" + self.parent.getCodePrintableID() + "_variant;")
     return code
 
 
diff --git a/tools/pyUANamespace/ua_node_types.py b/tools/pyUANamespace/ua_node_types.py
index af86e703ad5..c87c9837486 100644
--- a/tools/pyUANamespace/ua_node_types.py
+++ b/tools/pyUANamespace/ua_node_types.py
@@ -1096,7 +1096,7 @@ def printOpen62541CCode_Subtype(self, unPrintedReferences=[], bootstrapping = Tr
     code.append(self.getCodePrintableID() + "->accessLevel = (UA_Int32) " + str(self.accessLevel()) + ";")
     code.append(self.getCodePrintableID() + "->valueRank = (UA_Int32) " + str(self.valueRank()) + ";")
     # The variant is guaranteed to exist by SubtypeEarly()
-    code.append(self.getCodePrintableID() + "->value.variant = *" + self.getCodePrintableID() + "_variant;")
+    code.append(self.getCodePrintableID() + "->value.variantAndCallback.variant = *" + self.getCodePrintableID() + "_variant;")
     return code
 
 class opcua_node_method_t(opcua_node_t):
@@ -1348,7 +1348,7 @@ def printOpen62541CCode_Subtype(self, unPrintedReferences=[], bootstrapping = Tr
       code.append(self.getCodePrintableID() + "->isAbstract = UA_FALSE;")
     
     # The variant is guaranteed to exist by SubtypeEarly()
-    code.append(self.getCodePrintableID() + "->value.variant = *" + self.getCodePrintableID() + "_variant;")
+    code.append(self.getCodePrintableID() + "->value.variantAndCallback.variant = *" + self.getCodePrintableID() + "_variant;")
     return code
 
 class opcua_node_dataType_t(opcua_node_t):
